/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;

import java.awt.Font;

/**
 * tmarkplugin.config.Property for a Font
 * @author Tomas Schackert
 *
 */
public class FontProperty extends ConditionalProperty{
	
	private String basekey;
	private Font value=null;
	private Font defaultvalue;
	
	public FontProperty(PropertySource props,FontProperty src){
		super(props);
		setFont(src);
	}
	public FontProperty(PropertySource props,String basekey,Font defaultvalue){
		super(props);
		this.basekey=basekey;
		this.defaultvalue=defaultvalue;
	}
	public FontProperty(PropertySource props,String basekey,Font defaultvalue,String condkey,boolean defaultcond){
		super(props,condkey,defaultcond);
		this.basekey=basekey;
		this.defaultvalue=defaultvalue;
	}
	public void setFont(FontProperty src){
		super.setCondition(src,false);
		if (src.value==null)src.load();
		this.basekey=src.basekey;
		this.defaultvalue=src.defaultvalue;
		setFont(src.value);
	}
	
	private void load(){
		value=getFontProperty(basekey,defaultvalue);
	}
	public Font getFont(){
		if (value==null) load();
		return value;
	}
	public void setFont(boolean cond,Font f){
		setCondition(cond,false);
		setFont(f);
	}
	public void setFont(Font f){
		this.setFontProperty(basekey,this.value=f);
		fireChanged();
	}
}
